<script lang="ts">
  import Logo from "./Logo.svelte"
  import { writable } from "svelte/store"

  const menuOpen = writable(false)

  function clickOutside(node: HTMLElement, { enabled }: { enabled: boolean }) {
    function handleClick(event: Event) {
      if (enabled && !node.contains(event.target as Node)) {
        menuOpen.set(false)
      }
    }

    document.addEventListener("click", handleClick)

    return {
      update(newOptions: { enabled: boolean }) {
        enabled = newOptions.enabled
      },
      destroy() {
        document.removeEventListener("click", handleClick)
      },
    }
  }
</script>

<header>
  <nav>
    <button class="circle transparent">
      <i>arrow_back</i>
    </button>
    <h5 class="max">Title</h5>
    <a href="/signup">
      <button> Sign Up </button>
    </a>
    <a href="/signin">
      <button class="secondary"> Sign In </button>
    </a>
    <button class="circle transparent">
      <i>today</i>
    </button>
    <button class="circle transparent">
      <i>notifications</i>
    </button>
    <button
      class="circle transparent"
      on:click={() => menuOpen.set(!$menuOpen)}
    >
      <i>account_circle</i>
    </button>
    {#if $menuOpen}
      <nav class="drawer" use:clickOutside={{ enabled: $menuOpen }}>
        <a href="/auth/signin">
          <i>login</i>
          <div>Sign In</div>
        </a>
        <a href="/auth/signup">
          <i>person_add</i>
          <div>Sign Up</div>
        </a>
        <a href="/user/profile">
          <i>person</i>
          <div>Profile</div>
        </a>
      </nav>
    {/if}
  </nav>
</header>

<nav class="left drawer l">
  <header>
    <nav>
      <Logo />
      <h6>Life.Stack</h6>
    </nav>
  </header>
  <a href="/">
    <i>home</i>
    <div>Home</div>
  </a>
  <a href="/calendar">
    <i>search</i>
    <div>Calendars</div>
  </a>
  <a>
    <i>share</i>
    <div>Lists</div>
  </a>
  <a>
    <i>more_vert</i>
    <div>Trackers</div>
  </a>
  <a>
    <i>more_vert</i>
    <div>Rewards</div>
  </a>
  <div class="divider" />
  <label>Label</label>
  <a>
    <i>widgets</i>
    <div>Group Management</div>
  </a>
  <a>
    <i>chat</i>
    <div>Chat</div>
  </a>
  <a>
    <i>help</i>
    <div>Help</div>
  </a>
</nav>

<nav class="left m">
  <header>
    <Logo />
  </header>
  <a>
    <i>home</i>
    <div>Home</div>
  </a>
  <a>
    <i>search</i>
    <div>Search</div>
  </a>
  <a>
    <i>share</i>
    <div>Share</div>
  </a>
  <a>
    <i>more_vert</i>
    <div>More</div>
  </a>
</nav>

<nav class="bottom s">
  <a>
    <i>home</i>
  </a>
  <a>
    <i>search</i>
  </a>
  <a>
    <i>share</i>
  </a>
  <a>
    <i>more_vert</i>
  </a>
</nav>
